package Test;

import editor.Gelaende;
import editor.Spielfeld;
import editor.SimulationController;
import editor.RoboterTyp;
import editor.AntriebsTyp;
import gameserver.Gameserver;
import gameserver.Roboter;

import java.awt.*;

/**
 *
 * User: Standard
 * Date: 04.11.2003
 * Time: 01:26:26
 *
 */
public class TestSimulationController extends Frame {

    public static void main(String args[]){
        //new Gelaende;
        Spielfeld spielfeld = new Spielfeld("Badezimmer1");

        SimulationController simcontrol = new SimulationController();

        RoboterTyp rtype = RoboterTyp.loadRoboterTyp("R2D2");

        Roboter r1 = new Roboter(rtype, "C3P1", spielfeld);
        r1.setX(10);
        r1.setY(10);
        r1.setAgentenName("SimpleMoveTestAgent");
		
        /* fehlende Daten:
            Schablonen
            Liegt aber an fehlerhaften Daten....
        */



        System.out.println("Robotername:" +  r1.getName());
        System.out.println("Agentenname:" +  r1.getAgentenName());
        spielfeld.addroboter(r1);


        simcontrol.initSimulation(spielfeld);
        
        try {
            simcontrol.startSimulation();
            simcontrol.killAgent("C3P0");
            Thread.sleep(10000);
            simcontrol.stopSimulation();
            System.exit(0);
        } catch (InterruptedException e) {
            e.printStackTrace();  //To change body of catch statement use Options | File Templates.
        }


    }
}
