package agent.impl;

import agent.agentgui.SimpleAgentVisualization;
import agent.Agent;
import mailbox.Message;
import mailbox.ScanResult;

import java.awt.*;


/**
 * Agent, der ein Rennen auf einer Karte von West nach Ost durchfhrt und
 * dabei Hindernissen ausweicht.
 *
 * User: Standard
 * Date: 09.11.2003
 * Time: 22:13:13
 *
 */
public class RaceAgent extends Agent {




    /**
     *
        Schleifen:  <br>
        while(running){ <br>
        versuche message zu holen (sonst NullPointerException)  <br>
        if(!canmove){     <br>
        - warte auf die BesttigungsMessage, da move fertig<br>
        }  else {<br>
        - tue Aktion  <br>
        - falls dabei ein move ausgefhrt wird, setze vorher canmove auf false,
        damit auf die Besttigung gewartet wird  <br>
        }<br>
        }  <br>


     */
    public void run(){
        sendMessageToServer(new Message(Message.TURNEAST)); // setzen der Startrichtung
        String[] sensoren = getRoboterInfo().getSensoren();
        String eye = sensoren[0];
        String tast = sensoren[1];
        int abweichungVonEAST = 0;
        boolean canmove = true;
        sendMessageToServer(new Message(Message.SCAN, sensoren[1])); // initial lse Tastsensor aus

        /*
        Schleifen:
        while(running){
        versuche message zu holen (sonst NullPointerException)
        if(!canmove){
        - warte auf die BesttigungsMessage, da move fertig
        }  else {
        - tue Aktion
        - falls dabei ein move ausgefhrt wird, setze vorher canmove auf false,
        damit auf die Besttigung gewartet wird
        }
        }
        */


        while(ivRunning){

            try {
                try {
                    Message m = getNextMessage();
                    if (!canmove){

                        if (m.getBetreff() == Message.MOVEFINISHED){
                            canmove = true;
                             if (abweichungVonEAST != 0){
                                        sendMessageToServer(new Message(Message.TURNEAST));
                                        // zurcksetzen der Abweichung und erneut versuchen
                                        abweichungVonEAST = 0;
                             }
                             sendMessageToServer(new Message(Message.SCAN, sensoren[1]));
                        } else {
                            // ansonsten wird die Nachricht implizit gelscht
                            System.out.println("Message erhaltensdasafsad: Absender: " + m.getAbsender() +" - Betreff: "+ m.getBetreff());
                        }
                    } else{  // tue etwas sinnvolles

                        if (m.getBetreff() == Message.SCANRESULT){


                            ScanResult lvScanErgebnis = (ScanResult) m.getContent();
                            if (lvScanErgebnis.getIvSensorName().equals(sensoren[1])){ // Tastsensor
                                // hole die Wahrnehmung!!!
                                String[][] lvWahrnehmung = lvScanErgebnis.getIvScanresult();
                                String ret="";
                                for(int i = 9; i < 12; i++){
                                    for (int j = 9; j < 12; j++){
                                        if (lvWahrnehmung[i][j] != null){
                                            ret = lvWahrnehmung[i][j];
                                        }
                                    }
                                }

                                System.out.println("Gelesene Wahrnehmung; " + ret);
                                if (ret.equals("nein")){
                                    // es ist etwas im weg, also drehen und nochmal scannen!!!!!
                                    abweichungVonEAST++;      // Drehe nach Sdost ab
                                    sendMessageToServer(new Message(Message.TURNEAST + abweichungVonEAST));
                                    sendMessageToServer(new Message(Message.SCAN, sensoren[1]));


                                }  else { // fhre einen Move durch
                                    canmove = false;
                                    sendMessageToServer(new Message(Message.MOVEFORWARD));
                                    // danach warten!!!!
                                    // Problem: es steht kein scan mehr aus
                                    // Annahme, wenn ein move durchgefhrt ist, dann mu danach gedreht und gescannt werden
                                }
                            }

                        } else {
                            // ansonsten wird die Nachricht implizit gelscht
                            System.out.println("Message erhalten: Absender: " + m.getAbsender() +" - Betreff: "+ m.getBetreff());
                        }

                    }

                } catch (Exception e) {       // Catcht die NullpointerException, falls keine Message da
                    Thread.sleep(100);
                }
            } catch (InterruptedException e) { // fr Thread.sleep()

            }
        }
    }







}
