package editor;

import java.awt.*;
import java.util.Vector;
import java.sql.*;
import java.util.Enumeration;

/**
 * Dies ist die Klasse fr Minenobjekte
 */

public class Mine {
  Sql db = new Sql();
  private String name;
  private Image bild;
  private int mid;
  private static Vector minen = new Vector(); //Container fr die Minenobjekte

  /**
   * Konstruktor zum Laden einer Mine aus der Datenbank
   * @param name Name der neuen Mine
   */
  public Mine(String name) {
    this.name = name;
    ResultSet result = db.select("select * from mine where name='" + name + "'");
    try {
      result.next();
      bild = (Toolkit.getDefaultToolkit().getImage(result.getString("bild")));
      mid = result.getInt("mid");
    }
    catch (SQLException ex) {
      System.out.println(ex);
    }

    minen.add(this);
  }

  /**
   * Suchen eines Minenobjektes
   * @param suchmine Name der zu suchenden Mine
   * @return gesuchtes Minenobjekt
   */

  public static Mine getmine(String suchmine) {
    Enumeration e = minen.elements();
    Mine m, returner;
    returner = null;
    while (e.hasMoreElements()) {
      m = ((Mine) e.nextElement());
      if (m.getname().equals(suchmine)) {
        returner = m;
      }
    }
    return returner;
  }

    /**
     * Methode zum lschen eines Minenobjektes
     * @param mine zu lschendes Minenobjekt
     */
  public static void deletemine(Mine mine) {
    minen.remove(mine);
  }

  /**
   * gibt das Bild dieser Mine zurck
   * @return Bild dieser Mine
   */

  public Image getbild() {
    return this.bild;
  }

  /**
   * gibt den Namen dieser Mine zurck
   * @return Name dieser Mine
   */
  public String getname() {
  return this.name;
}

 /**
  * Gibt die gesuchte Sensormeldung zurck
  * @param gelaende abgetastetes Gelnde
  * @param sichtbereich abgefragter sichtbereich
  * @param sensor Sensor mit dem gescannt wurde
  * @return gesuchte Sensormeldung sensormeldung
  */
  public Object getsensormeldung(String gelaende, int sichtbereich,
                                 String sensor) {
    Object returner = null;
    ResultSet result;
    int gid = 0;
    int sid = 0;
    result = db.select("select gid from gelaende where name='" + gelaende + "'");
    try {
      result.next();
      gid = result.getInt("gid");
    }
    catch (SQLException ex) {
      System.out.println(ex);
    }
    result = db.select("select sid from sensor where name='" + sensor + "'");
    try {
      result.next();
      sid = result.getInt("sid");
    }
    catch (SQLException ex1) {
      System.out.println(ex1);
    }
    result = db.select("select meldung from sensormeldung where mid='" + mid +
                       "'and gid='" + gid + "'and sid='" + sid +
                       "'and sensorebene='" + sichtbereich + "'");
    try {
      result.next();
      returner = result.getString("meldung");
    }
    catch (SQLException ex2) {
    }
    return returner;
  }

  //Mainmethode zu Testzwecken
  public static void main(String args[]) {
    Mine m = new Mine("Tretmine");
    System.out.print(m.getsensormeldung("Baum", 1, "Sicht"));
  }
}
