package agent.impl;

import agent.Agent;

import java.util.Vector;
import java.util.Random;

import mailbox.Message;

/**
 * Demo-Agent, der sich mit anderen Ping-Agenten Nachrichten schickt.
 * Eine Robotersteuerung findet nicht statt.
 * User: Standard
 * Date: 08.11.2003
 * Time: 16:38:21
 *
 */
public class DatingAgent extends Agent{

    private Vector myFriends = new Vector();
    private Random r = new Random(Math.round((Math.random()* 40000)));

    public void run(){
        while(isRunning()){

            try {
                Thread.sleep(1000 + r.nextInt(2000));
            } catch (InterruptedException e) {

            }
            sendBroadCastToAgents(new Message(Message.PING, "Anybody out there?"));
            sendMessageToServer(new Message(Message.PING, "Anybody out there?"));
             try {
                Thread.sleep(1000 + r.nextInt(2000));
                Message m = getNextMessage();

                 try {
                     if (m.getAbsender().equals(Message.SERVER)){
                         log("Hey, it\'s my Server!");

                     }  else {
                         log ("Finally I found a Friend!! His name is: " + m.getAbsender()
                                 + "\nI will greet him!!!");
                         sendMessageToAgent(new Message(Message.PING, "Hello, how are you"), m.getAbsender());

                     }
                 } catch (Exception e) {
                     log("Keine Post...");
                 }
             } catch (InterruptedException e) {

            }


        }
    }

    private void log(String msg){
        System.out.println(getClass().toString() + " " + getName() + " -> " + msg);
    }

}
