package editor;

import java.sql.*;
import java.awt.*;
import java.awt.event.*;
import com.borland.jbcl.layout.*;
  /**
   * In dieser Klasse befinden sich die Oberflchen frs ndern und Anlegen von Antrieben.
   */
public class Antriebgui
    extends Frame {

  // Erstellen der bentigten Datenbankzugriffsobjekte
  Sql db = new Sql();
  Sql db2 = new Sql();

  private int aid = 0; // wird gesetzt wenn ein Datensatz zu ndern ist
  XYLayout xYLayout1 = new XYLayout();
  Label label1 = new Label();
  Label label2 = new Label();
  Label label3 = new Label();
  TextField tname = new TextField();
  TextField tgewicht = new TextField();

  Button babbrechen = new Button();
  Button beintragen = new Button();
  XYLayout xYLayout2 = new XYLayout();
  /**
   * Konstruktor fr einen neuen Antrieb
   */
  public Antriebgui() {
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }
  /**
   * Konstruktor fr das ndern des Antriebes
   * @param zuandern Name des zu ndernden Antriebes
   */

  public Antriebgui(String zuandern) {
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    ResultSet altedaten;
    altedaten = db.select("Select * from antrieb where name='" + zuandern + "'");
    try {
      altedaten.next();
      tgewicht.setText(altedaten.getString("gewicht"));
      tname.setText(altedaten.getString("name"));
      beintragen.setLabel("ndern");
      label1.setText("Antrieb ndern");
      aid = altedaten.getInt("aid");
      altedaten = db.select("Select * from passierbarkeit where aid='" + aid +
                            "'");
      int i = 0;
      while (altedaten.next()) {
        ( (TextField) (ergebnisse[i][0])).setText(altedaten.getString(
            "energieverbrauch"));
        ( (TextField) (ergebnisse[i][1])).setText(altedaten.getString(
            "geschwindigkeit"));
        ( (Checkbox) (ergebnisse[i][2])).setState(altedaten.getBoolean(
            "passierbarkeit"));
        i++;
      }
    }
    catch (SQLException ex) {
    }

  }

  private int anzahlgelaende;
  private Object[][] ergebnisse;
  private String[] gelaendetypen;
  TextField tstverbrauch = new TextField();
  TextField tstdauer = new TextField();
  Button bstenergie = new Button();
  Button bstdauer = new Button();

  private void jbInit() throws Exception {
    label1.setFont(new java.awt.Font("Dialog", 1, 15));
    label1.setText("Neuen Antrieb anlegen");
    this.setLayout(xYLayout1);
    label2.setFont(new java.awt.Font("Dialog", 0, 13));
    label2.setText("Name:");
    label3.setFont(new java.awt.Font("Dialog", 0, 13));
    label3.setText("Gewicht:");
    tname.setText("");
    tgewicht.setText("");

    ResultSet result;

    result = db.select("select * from gelaende,umggelaendez where gelaende.gid=umggelaendez.gid and umggelaendez.uid='"+Editor.getumgebung()+"'");
    result.last();
    anzahlgelaende = result.getRow();
    gelaendetypen = new String[anzahlgelaende];
    xYLayout1.setWidth(474);
    xYLayout1.setHeight(120+anzahlgelaende*20);
    Panel panel = new Panel();
    panel.setLayout(xYLayout2);
    xYLayout2.setHeight( (anzahlgelaende + 1) * 20);
    this.setBackground(SystemColor.menu);
    beintragen.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        beintragen_actionPerformed(e);
      }
    });

    tstverbrauch.setText("");
    tstdauer.setText("");

    bstenergie.setLabel("Standardverbrauch:");
    bstenergie.setLocale(java.util.Locale.getDefault());
    bstenergie.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        bstenergie_actionPerformed(e);
      }
    });

    bstdauer.setLabel("Standarddauer:");
    bstdauer.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        bstdauer_actionPerformed(e);
      }
    });

    panel.add(new Label("Gelnde"), new XYConstraints(0, 0, 50, 20));
    panel.add(new Label("Energieverbrauch"), new XYConstraints(100, 0, 100, 20));
    panel.add(new Label("Geschwindigkeit"), new XYConstraints(220, 0, 100, 20));
    panel.add(new Label("Passierbarkeit"), new XYConstraints(330, 0, 150, 20));

    result = db.select("select * from gelaende,umggelaendez where gelaende.gid=umggelaendez.gid and umggelaendez.uid='"+Editor.getumgebung()+"'");
    int i = 1;
    ergebnisse = new Object[anzahlgelaende][3];
    try {
      while (result.next()) {
        Label l = new Label(result.getString("name"));
        gelaendetypen[i - 1] = result.getString("name");
        TextField energie = new TextField();
        TextField speed = new TextField();
        Checkbox passbar = new Checkbox();
        ergebnisse[i - 1][0] = energie;
        ergebnisse[i - 1][1] = speed;
        ergebnisse[i - 1][2] = passbar;
        panel.add(l, new XYConstraints(0, i * 20, 95, 20));
        panel.add( (Component) (ergebnisse[i - 1][0]),
                  new XYConstraints(100, i * 20, 50, 20));
        panel.add( (Component) (ergebnisse[i - 1][1]),
                  new XYConstraints(230, i * 20, 50, 20));
        panel.add( (Component) (ergebnisse[i - 1][2]),
                  new XYConstraints(360, i * 20, 50, 20));
        i++;
      }
    }
    catch (SQLException ex) {
      System.out.println("Problem");
    }

    babbrechen.setLabel("Abbrechen");
    babbrechen.addActionListener(new Antriebgui_babbrechen_actionAdapter(this));
    beintragen.setLabel("Eintragen");
    panel.setBackground(Color.lightGray);
    panel.setEnabled(true);
    this.add(label1, new XYConstraints(99, 9, 176, 22));
    this.add(label2, new XYConstraints(32, 45, 65, 19));
    this.add(label3, new XYConstraints(32, 67, 65, 19));
    this.add(tname, new XYConstraints(113, 47, 101, 19));
    this.add(tgewicht, new XYConstraints(113, 69, 101, 19));
    this.add(panel, new XYConstraints(10, 130, 445, 280));
    this.add(babbrechen, new XYConstraints(245, 46, 125, 19));
    this.add(beintragen, new XYConstraints(245, 69, 125, 19));
    this.add(bstenergie, new XYConstraints(10, 108, 136, 19));
    this.add(tstverbrauch, new XYConstraints(150, 108, 85, 19));
    this.add(bstdauer, new XYConstraints(246, 108, 119, 19));
    this.add(tstdauer, new XYConstraints(368, 108, 83, 19));

    addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        dispose();
      }
    });
    label1.setVisible(true);
    setTitle("Antrieb anlegen");
    pack();
    setVisible(true);

  }

  void babbrechen_actionPerformed(ActionEvent e) {
    dispose();
  }

  public static void main(String args[]) {
    Antriebgui gui = new Antriebgui("Kette");
  }

  void beintragen_actionPerformed(ActionEvent e) {
    boolean fehler = false;
    String aid = new String();
    ResultSet aidres;
    aidres = (db2.select("select aid,name from antrieb where name ='" +
                        tname.getText() + "'"));
    try {
      aidres.next();
      aid = aidres.getString("aid");
    }
    catch (SQLException ex1) {
      System.out.println("Prolem bei aidholen" + ex1);
    }

    ResultSet result;
    result = db.select("select name from antrieb");
    try {
      if (this.aid == 0 || Integer.parseInt(aid)!=this.aid) {
        while(result.next()){
        if (result.getString("name").equals(tname.getText())) {

          Warnung w = new Warnung("" + tname.getText() + " gibt es schon!");
          fehler = true;
        }
        }

      }
    }
    catch (SQLException ex2) {
      System.out.println(ex2);
    }

    if ( (tname.getText().equals("") || tgewicht.getText().equals("") || !tgewicht.getText().matches("[\\d]*")) &&
        !fehler) {
      Warnung w = new Warnung("Bitte alle Felder gltig ausfllen!");
      fehler = true;
    }
    for (int i=0; i<anzahlgelaende; i++){
      if(
      ( (TextField) ergebnisse[i][0]).getText().matches("[\\d]*")&&
      ( (TextField) ergebnisse[i][1]).getText().matches("[\\d]*"));
  else {
    fehler = true;
    Warnung w = new Warnung("Fr Energieverbrauch und Geschwindigkeit sind nur Zahlen erlaubt!");
  }

    }

    if (!fehler) {
      if (this.aid == 0) {
        db.mach("insert into antrieb (name, gewicht) values ('" + tname.getText() +
                "','" + tgewicht.getText() + "')");
      }
      else {
        db.mach("update antrieb set name='" + tname.getText() + "', gewicht='" +
                tgewicht.getText() + "' where aid='" + aid + "'");
      }

      String gid = new String();
      int i = 0;
      int j = 0;
      ResultSet aidresult;
      aidresult = (db.select("select aid from antrieb where name ='" +
                             tname.getText() + "'"));
      try {
        aidresult.next();
        aid = aidresult.getString("aid");
      }
      catch (SQLException ex1) {
        System.out.println("Problem bei aidholen" + ex1);
      }

      ResultSet anzres=db2.select("Select distinct gid from passierbarkeit"); //marker
      int anzahlgids=0;
      try {
        anzres.last();
        anzahlgids=anzres.getRow();
      }
      catch (SQLException ex3) {
      }

      if (!fehler) {
        for (i = 0; i < anzahlgelaende; i++) {
          ResultSet gidres;
          gidres = (db.select("select gid from gelaende where name='" +
                              gelaendetypen[i] + "'"));
          try {
            gidres.next();
            gid = gidres.getString("gid");
          }
          catch (SQLException ex) {
            System.out.println("Problem bei gidholen" + ex);
          }


          if (this.aid == 0||i>=anzahlgids) {
            db.mach("insert into passierbarkeit (aid, gid, geschwindigkeit, energieverbrauch, passierbarkeit)values ('" +
                    aid + "','" + gid + "','" +
                    ( (TextField) ergebnisse[i][1]).getText() + "','" +
                    ( (TextField) ergebnisse[i][0]).getText() + "','" +
                    ( (Checkbox) ergebnisse[i][2]).getState() + "')");
          }
          else {
            db.mach("delete from passierbarkeit  where aid='" +
                    aid + "' and gid='" + gid + "'");
            db.mach("insert into passierbarkeit (aid, gid, geschwindigkeit, energieverbrauch, passierbarkeit)values ('" +
                    aid + "','" + gid + "','" +
                    ( (TextField) ergebnisse[i][1]).getText() + "','" +
                    ( (TextField) ergebnisse[i][0]).getText() + "','" +
                    ( (Checkbox) ergebnisse[i][2]).getState() + "')");

          }
        }
      }
      dispose();

    }

  }

  void bstenergie_actionPerformed(ActionEvent e) {
    for (int i = 1; i <= anzahlgelaende; i++) {
      ( (TextField) ergebnisse[i - 1][0]).setText(tstverbrauch.getText());
    }
  }

  void bstdauer_actionPerformed(ActionEvent e) {
    for (int i = 1; i <= anzahlgelaende; i++) {
      ( (TextField) ergebnisse[i - 1][1]).setText(tstdauer.getText());
    }

  }

}

class Antriebgui_babbrechen_actionAdapter
    implements java.awt.event.ActionListener {
  Antriebgui adaptee;

  Antriebgui_babbrechen_actionAdapter(Antriebgui adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.babbrechen_actionPerformed(e);
  }
}

class Antriebgui_beintragen_actionAdapter
    implements java.awt.event.ActionListener {
  Antriebgui adaptee;

  Antriebgui_beintragen_actionAdapter(Antriebgui adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.beintragen_actionPerformed(e);
  }
}

