package editor;

import java.awt.*;
import com.borland.jbcl.layout.*;
import java.awt.event.*;
import java.sql.*;
/**
 * Oberflge zum neu anlegen und ndern von Spielfeldern
 */
public class Spielfeldgui
    extends Panel {
  //erstellen der bentigten Datenbankverbindungen
  Sql db = new Sql();
  Sql db2 = new Sql();
  int andernid = 0; //id des zu ndernden Spielfeldes, 0 beim neu anlegen
  String altername = new String();

  int laenge, breite;
  String[][] hoehen;
  String[][] mines;
  String[][] gelaendes;
  Image[] gelaendebilder;
  int[] gelaendebreiten; //Ausmae aller
  int[] gelaendelaengen; //Gelnde
  Image[] minenbilder;
  spielfeld sp;
  ScrollPane feldhalter;
  Checkbox cedit;
  Checkbox cshow;
  Checkbox cbhoehen;
  Checkbox cbminen;
  Checkbox cbgelaende;

  CheckboxGroup cgmodus = new CheckboxGroup();
  Label label1 = new Label();
  XYLayout xYLayout1 = new XYLayout();
  Label label6 = new Label();
  Label label8 = new Label();
  Label label9 = new Label();
  Button babbrechen = new Button();
  Button bspeichern = new Button();
  Label label4 = new Label();
  TextField tname = new TextField();
  Choice cgelaende = new Choice();
  Choice cmine = new Choice();
  Choice choehe = new Choice();
  Choice czoom = new Choice();
  Label label10 = new Label();
  Label label11 = new Label();
  Checkbox cbgelaendewrite = new Checkbox();
  Checkbox cbminenwrite = new Checkbox();
  Checkbox cbhoehenwrite = new Checkbox();
  Label label5 = new Label();
  TextField tumgebung = new TextField();

    /**
     * Konstruktor fr ein neu zu erstellendes Spielfeld in einer bestimmten Umgebung ohne Standartgelnde
     * @param laenge Lnge des Spielfeldes
     * @param breite Breite des Spielfeldes
     * @param umgebung Umgebung in der das Spielfeld erstellt werden soll
     */
  public Spielfeldgui(int laenge, int breite, String umgebung) {
    tumgebung.setText(umgebung);
    this.laenge = laenge;
    this.breite = breite;
    mines = new String[breite][laenge];
    hoehen = new String[breite][laenge];
    gelaendes = new String[breite][laenge];
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

    /**
     * Konstruktor fr ein neu zu erstellendes Spielfeld in einer bestimmten Umgebung mit Standartgelnde
     * @param laenge Lnge des Spielfeldes
     * @param breite Breite des Spielfeldes
     * @param standardgelaende Gelnde, mit dem das neue Spielfeld zu Beginn bedeckt ist
     * @param umgebung Umgebung in der das Spielfeld erstellt werden soll
     */
  public Spielfeldgui(int laenge, int breite, String standardgelaende, String umgebung) {
    tumgebung.setText(umgebung);
    this.laenge = laenge;
    this.breite = breite;
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    mines = new String[breite][laenge];
    hoehen = new String[breite][laenge];
    gelaendes = new String[breite][laenge];
    ResultSet result;
    result = db.select("select laenge, breite from gelaende where name='" +
                       standardgelaende + "'");
    try {
      result.last();
      int anzahlgelaende = result.getRow();
      result.first();
      int gelaende = 0;
      int y;
      for (int i = 0; i < cgelaende.getItemCount(); i++) {
        if (standardgelaende.equals(cgelaende.getItem(i))) {
          gelaende = i;
        }
      }
      System.out.println(gelaende);
      int b = result.getInt("breite");
      int l = result.getInt("laenge");
      for (int x = 0; x < breite; x++) {
        for (int k = 0; k < laenge; k++) {
          y = laenge - k - 1;
          if (x >= 0 && x < breite && y >= 0 && y < laenge) {
            if (x + b > breite || y - l + 1 < 0) {
              //System.out.println("Gelnde ragt raus");
            }
            else {
              for (int i = 0; i < b; i++) {
                for (int j = 0; j < l; j++) {
                  gelaendes[x + i][laenge - 1 -
                      y + j] = "/" + x + "/" + (laenge - 1 - y);
                }
              }
              if (gelaendes[x][laenge - 1 - y] != null) {
                gelaendes[x][laenge - 1 - y] = String.valueOf(gelaende);
              }
            }
          }

          if (l > 1) {
            k += l - 1;

          }
        }
        if (b > 1) {
          x += b - 1;
        }
      }
    }

    catch (SQLException ex) {
      System.out.println(ex);
    }

  }
 /**
  * Konstruktor fr ein zu nderndes Spielfeld
  * @param zuandern name des zu ndernden Spielfeldes
  */
  public Spielfeldgui(String zuandern) {

    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    ResultSet altedaten;
    altedaten = db.select("select * from spielfeld where name='" + zuandern +
                          "'");
    try {
      altedaten.next();
      altername = altedaten.getString("name");
      andernid = altedaten.getInt("spid");
      tname.setText(altedaten.getString("name"));
      this.laenge = altedaten.getInt("laenge");
      this.breite = altedaten.getInt("breite");
      mines = new String[breite][laenge];
      hoehen = new String[breite][laenge];
      gelaendes = new String[breite][laenge];
      ResultSet umgresult =db.select("select uname from umgebung where uid='"+altedaten.getInt("uid")+"'");
      umgresult.next();
      tumgebung.setText(umgresult.getString("uname"));
      ResultSet kresult = db.select(
          "select mid, gelaende.gid, laenge, breite, x,y,gelaende.name as gelaende, kachel.hoehe from kachel, gelaende where spid='" +
          andernid + "' and gelaende.gid=kachel.gid");

      ResultSet mresult = db2.select("select * from mine");
      int x, y, k;
      int gelaende = 0;
      Gelaende g;

      while (kresult.next()) {
        x = kresult.getInt("x");
        y = kresult.getInt("y");
        if (kresult.getString("mid").equals("")) {
          mines[x][y] = null;
        }
        else {
          mresult.beforeFirst();
          k = 0;
          while (mresult.next()) {
            if (mresult.getInt("mid") == kresult.getInt("mid")) {
              mines[x][y] = String.valueOf(k);
              k++;
            }
          }
        }
        for (int i = 0; i < cgelaende.getItemCount(); i++) {
          if (kresult.getString("gelaende").equals(cgelaende.getItem(i))) {
            gelaende = i;
          }
        }

        gelaendes[x][y] = String.valueOf(gelaende);
        if (kresult.getInt("breite") > 1 || kresult.getInt("laenge") > 1) {
          for (int i = 0; i < kresult.getInt("breite"); i++) {
            for (int j = 0; j < kresult.getInt("laenge"); j++) {
              if (gelaendes[x + i][y + j] == null) {
                gelaendes[x + i][y + j] = "/" + x + "/" + y;
              }
            }
          }
        }

        hoehen[x][y] = kresult.getString("hoehe");
        if (kresult.getInt("laenge") > 1 || kresult.getInt("breite") > 1) {
          for (int i = 0; i < kresult.getInt("breite"); i++) {
            for (int j = 0; j < kresult.getInt("laenge"); j++) {
              hoehen[x + i][y + j] = kresult.getString("hoehe");
            }
          }

        }
      }
    }

    catch (SQLException ex) {
      System.out.println(ex);
    }
  }

  public static void main(String[] args) {
    Frame f = new Frame();
    f.setSize(Toolkit.getDefaultToolkit().getScreenSize());
    Spielfeldgui spielfeldgui1 = new Spielfeldgui(100,100,"Wald","Alles");
    f.add(spielfeldgui1);
    f.addWindowListener(new WindowAdapter() {
      public void windowClosing(WindowEvent e) {
        System.exit(0);
      }
    });
    f.setVisible(true);
  }

  private void jbInit() throws Exception {
    label1.setFont(new java.awt.Font("Dialog", 1, 15));
    label1.setText("Neues Spielfeld erstellen");
    this.setLayout(xYLayout1);
    label6.setText("Gelnde:");
    label6.setFont(new java.awt.Font("Dialog", 0, 13));
    label8.setText("Mine:");
    label8.setFont(new java.awt.Font("Dialog", 0, 13));
    label9.setText("Hhe:");
    label9.setVisible(true);
    label9.setFont(new java.awt.Font("Dialog", 0, 13));
    cedit = new Checkbox("Schreiben", cgmodus, false);
    cshow = new Checkbox("Zeigen", cgmodus, true);
    cbhoehen = new Checkbox("Hhen", true);
    cbminen = new Checkbox("Minen", true);
    cbgelaende = new Checkbox("Gelnde", true);
    this.setBackground(SystemColor.menu);
    cedit.setCheckboxGroup(cgmodus);
    cedit.setFont(new java.awt.Font("Dialog", 0, 13));
    cedit.setLabel("Schreiben:");
    cshow.setCheckboxGroup(cgmodus);
    cshow.setFont(new java.awt.Font("Dialog", 0, 13));
    cshow.setLabel("Zeigen:");
    cshow.setState(true);
    cbhoehen.setFont(new java.awt.Font("Dialog", 0, 13));
    cbhoehen.addItemListener(new Spielfeldgui_cbhoehen_itemAdapter(this));
    cbminen.setFont(new java.awt.Font("Dialog", 0, 13));
    cbminen.addItemListener(new Spielfeldgui_cbminen_itemAdapter(this));
    cbgelaende.setFont(new java.awt.Font("Dialog", 0, 13));
    cbgelaende.addItemListener(new Spielfeldgui_cbgelaende_itemAdapter(this));
    babbrechen.setEnabled(true);
    babbrechen.setFont(new java.awt.Font("Dialog", 0, 13));
    babbrechen.setLabel("Abbrechen");
    babbrechen.addActionListener(new Spielfeldgui_babbrechen_actionAdapter(this));
    bspeichern.setEnabled(true);
    bspeichern.setFont(new java.awt.Font("Dialog", 0, 13));
    bspeichern.setLabel("Speichern");
    bspeichern.addActionListener(new Spielfeldgui_bspeichern_actionAdapter(this));
    label4.setText("Name:");
    label4.setFont(new java.awt.Font("Dialog", 2, 13));
    tname.setText("");
    xYLayout1.setWidth(967);
    xYLayout1.setHeight(466);
    label10.setFont(new java.awt.Font("Dialog", 0, 13));
    label10.setVisible(true);
    label10.setText("Zoom:");
    label11.setText("%");
    label11.setVisible(true);
    label11.setFont(new java.awt.Font("Dialog", 0, 13));
    czoom.addItemListener(new Spielfeldgui_czoom_itemAdapter(this));
    cbgelaendewrite.setFont(new java.awt.Font("Dialog", 0, 13));
    cbgelaendewrite.setLabel("Gelnde");
    cbgelaendewrite.setState(true);
    cbminenwrite.setFont(new java.awt.Font("Dialog", 0, 13));
    cbminenwrite.setLabel("Mine");
    cbminenwrite.setState(true);
    cbhoehenwrite.setFont(new java.awt.Font("Dialog", 0, 13));
    cbhoehenwrite.setLabel("Hhe");
    cbhoehenwrite.setState(true);
    label5.setFont(new java.awt.Font("Dialog", 2, 13));
    label5.setText("Umgebung:");
    tumgebung.setEditable(false);
    this.add(label1, new XYConstraints(393, 5, -1, -1));
    this.add(label4, new XYConstraints(6, 36, 51, 19));

    czoom.add("25");
    czoom.add("50");
    czoom.add("75");
    czoom.add("100");
    czoom.add("125");
    czoom.add("150");
    czoom.select("100");

    ResultSet result;
    result = db.select("select * from gelaende ,umggelaendez where gelaende.gid=umggelaendez.gid and umggelaendez.uid='"+Editor.getumgebung()+"'");
    try {
      result.last();
      gelaendebilder = new Image[result.getRow() + 1];
      gelaendelaengen = new int[result.getRow() + 1];
      gelaendebreiten = new int[result.getRow() + 1];
      result.beforeFirst();
      int z = 0;
      while (result.next()) {
        cgelaende.add(result.getString("name"));
        Image img = Toolkit.getDefaultToolkit().getImage(result.getString(
            "bild"));
        gelaendebilder[z] = img;
        gelaendelaengen[z] = result.getInt("laenge");
        gelaendebreiten[z] = result.getInt("breite");
        z++;
      }
    }
    catch (SQLException ex) {
      System.out.println("Problem bei Gelndepulldown " + ex);
    }
    cgelaende.add("");

    result = db.select("select mine.mid, mine.name, mine.bild from mine,umgminez where mine.mid=umgminez.mid and umgminez.uid='"+Editor.getumgebung()+"'");
    try {
      result.last();
      minenbilder = new Image[result.getRow() + 1];
      result.beforeFirst();
      int z = 0;
      while (result.next()) {
        cmine.add(result.getString("name"));
        Image img = Toolkit.getDefaultToolkit().getImage(result.getString(
            "bild"));
        minenbilder[z] = img;
        z++;
      }
    }
    catch (SQLException ex) {
      System.out.println("Problem bei Minenpulldown " + ex);
    }
    cmine.add("");

    for (int i = 0; i <= 10; i++) {

      choehe.add("" + i);

    }
    choehe.add("");
    feldhalter = new ScrollPane();
    sp = new spielfeld(true, true, true);

    sp.setSize( (Integer.valueOf(czoom.getSelectedItem()).intValue() /
                5) * laenge,
              (Integer.valueOf(czoom.getSelectedItem()).intValue() /
               5) * breite);
    feldhalter.add(sp);
    this.add(feldhalter,
             new XYConstraints(5, 100,
                               ( (int) Toolkit.getDefaultToolkit().
                                getScreenSize().
                                getWidth()) - 10,
                               ( (int) Toolkit.getDefaultToolkit().
                                getScreenSize().
                                getHeight()) - 140));
    this.add(label5, new XYConstraints(6, 70, 71, 19));
    this.add(label10, new XYConstraints(452, 36, 40, 23));
    this.add(babbrechen, new XYConstraints(626, 36, 117, 26));
    this.add(label6, new XYConstraints(452, 70, 53, 23));
    this.add(cgelaende, new XYConstraints(508, 70, 107, 21));
    this.add(cmine, new XYConstraints(663, 70, 106, 21));
    this.add(label9, new XYConstraints(775, 70, 40, 23));
    this.add(choehe, new XYConstraints(815, 70, 58, 21));
    this.add(label8, new XYConstraints(626, 70, 39, 23));
    this.add(bspeichern, new XYConstraints(755, 36, 118, 26));
    this.add(czoom, new XYConstraints(508, 36, 55, -1));
    this.add(label11, new XYConstraints(566, 36, 18, 23));
    this.add(cbgelaende, new XYConstraints(275, 36, 68, -1));
    this.add(cbgelaendewrite, new XYConstraints(275, 70, -1, 19));
    this.add(cbminen, new XYConstraints(344, 36, -1, -1));
    this.add(cbminenwrite, new XYConstraints(344, 70, 49, 19));
    this.add(cbhoehen, new XYConstraints(397, 36, 56, -1));
    this.add(cbhoehenwrite, new XYConstraints(397, 70, 52, 19));
    this.add(cshow, new XYConstraints(192, 36, -1, -1));
    this.add(cedit, new XYConstraints(192, 70, -1, -1));
    this.add(tname, new XYConstraints(78, 36, 107, 24));
    this.add(tumgebung, new XYConstraints(78, 70, 107, 24));
    sp.setSize( (Integer.parseInt(czoom.getSelectedItem()) / 5) * breite + 2,
              (Integer.parseInt(czoom.getSelectedItem()) / 5) * laenge + 2);
    sp.setVisible(true);
    feldhalter.doLayout();
    setVisible(true);
  }

  void babbrechen_actionPerformed(ActionEvent e) {
    setVisible(false);
  }
 /**
  * in dieser Klasse werden einige Spielfelddaten gespeichert, sie wird bentigt
  * um das Spielfeld malen zu knnen
  */

  private class spielfeld
      extends Canvas {

    private boolean gelaende, hoehe, minen;
    /**
     * Konstruktor dieses Spielfeldes
     * @param gelaende  legt fest ob Gelnde mitgemalt werden sollen
     * @param hoehe    legt fest ob Hhen mitgemalt werden sollen
     * @param minen    legt fest ob Minen mitgemalt werden sollen
     */
    public spielfeld(boolean gelaende, boolean hoehe,
                     boolean minen) {
      this.gelaende = gelaende;
      this.hoehe = hoehe;
      this.minen = minen;
      this.addMouseListener(new MouseAdapter() {
        public void mousePressed(MouseEvent e) {

          int groesse = (Integer.valueOf(czoom.getSelectedItem()).intValue() /
                         5);
          int x = (e.getX() - e.getX() % groesse) / groesse;
          int y = ( (e.getY() - e.getY() % groesse) / groesse) *
              -1 + laenge - 1;
          if (x >= 0 && x < breite && y >= 0 && y < laenge) {
            if (cedit.getState()) {
              if (cbhoehenwrite.getState()) {
                hoehen[x][laenge - 1 - y] = choehe.getSelectedItem();
              }

              if (cbgelaendewrite.getState()) {
                int b = 1;
                int l = 1;
                ResultSet result;
                if (cgelaende.getSelectedIndex() ==
                    cgelaende.getItemCount() - 1) {
                  loeschegelaende(x, y);
                }
                else {

                  ResultSet aresult = db.select(
                      "select * from gelaende where name='" +
                      cgelaende.getSelectedItem() + "'");
                  try {
                    aresult.next();
                    b = aresult.getInt("breite");
                    l = aresult.getInt("laenge");
                  }
                  catch (SQLException ex) {
                    System.out.println(ex);
                  }
                  if (x + b > breite || y - l + 1 < 0) {
                    System.out.println("Gelnde ragt raus");
                  }
                  else {
                    for (int i = 0; i < b; i++) {
                      for (int j = 0; j < l; j++) {
                        if (gelaendes[x + i][laenge - 1 - y + j] != null) {
                          loeschegelaende(x + i, y - j);
                        }
                        gelaendes[x + i][laenge - 1 -
                            y + j] = "/" + x + "/" + (laenge - 1 - y);
                      }
                    }

                    gelaendes[x][laenge - 1 -
                        y] = String.valueOf(cgelaende.getSelectedIndex());
                  }
                }
              }

              if (cbminenwrite.getState()) {
                if (cmine.getSelectedIndex() == cmine.getItemCount() - 1) {
                  mines[x][laenge - 1 - y] = null;
                }
                else {
                  mines[x][laenge - 1 -
                      y] = String.valueOf(cmine.getSelectedIndex());
                }
              }

              repaint();

            }

            else {
              if (gelaendes[x][laenge - 1 - y].charAt(0) == '/' &&
                  gelaendes[x][laenge - 1 - y] != null) {
                int[] koordinaten = new int[2];
                koordinaten = getkoordinaten(gelaendes[x][laenge - 1 - y]);
                x = koordinaten[0];
                y = laenge - 1 - koordinaten[1];
              }

              if (gelaendes[x][laenge - 1 - y] != null) {

                cgelaende.select(Integer.parseInt(gelaendes[x][laenge - 1 -
                                                  y]));

                cgelaende.repaint();
              }
              else {
                cgelaende.select(cgelaende.getItemCount() - 1);
                cgelaende.repaint();
              }
              if (mines[x][laenge - 1 - y] != null) {
                cmine.select(Integer.parseInt(mines[x][laenge - 1 - y]));
                cmine.repaint();
              }
              else {
                cmine.select(cmine.getItemCount() - 1);
                cmine.repaint();
              }

              if (hoehen[x][laenge - 1 - y] != null) {
                choehe.select(Integer.parseInt(hoehen[x][laenge - 1 - y]));
                choehe.repaint();
              }
              else {
                choehe.select(choehe.getItemCount() - 1);
                choehe.repaint();
              }

            }

          }

        }

      });

      this.setVisible(true);
    }

    public void paint(Graphics g) {

      int i = 0;
      int groesse = Integer.parseInt(czoom.getSelectedItem()) / 5;
      for (i = 0; i <= laenge; i++) { // Horizontale Linien
        g.drawLine(1, i * groesse, groesse * breite, i * groesse);
      }
      for (i = 0; i <= breite; i++) { // Vertikale Linien
        g.drawLine(i * groesse, 1, i * groesse, groesse * laenge);
      }
      if (cbgelaende.getState()) {
        for (int y = 0; y < laenge; y++) {
          for (int x = 0; x < breite; x++) {
            if (gelaendes[x][y] != null && gelaendes[x][y].charAt(0) != '/') {
              int b = gelaendebreiten[Integer.parseInt(gelaendes[x][y])];
              int l = gelaendelaengen[Integer.parseInt(gelaendes[x][y])];
              Image img = gelaendebilder[Integer.parseInt(gelaendes[x][y])];

              g.drawImage(img, x * groesse, y * groesse, groesse * b,
                          groesse * l, this);

            }
          }

        }
      }
      if (cbminen.getState()) {
        for (int y = 0; y < laenge; y++) {
          for (int x = 0; x < breite; x++) {
            if (mines[x][y] != null) {
              Image img = minenbilder[ ( (int) Integer.parseInt(mines[x][y]))];
              g.drawImage(img, x * groesse, y * groesse, groesse, groesse, this);
            }
          }

        }
      }
      if (cbhoehen.getState()) {
        for (int y = 0; y < laenge; y++) {
          for (int x = 0; x < breite; x++) {

            if (hoehen[x][y] == null) {
              hoehen[x][y] = "0";
            }
            if (hoehen[x][y] != null) {
              g.drawString("" + hoehen[x][y], x * groesse + 5,
                           y * groesse + 13);
            }
          }
        }
      }
    }
  }

  public static int[] getkoordinaten(String s) {
    int[] returner = new int[2];
    returner[0] = Integer.parseInt(s.substring(s.indexOf('/') + 1,
                                               s.lastIndexOf('/')));
    returner[1] = Integer.parseInt(s.substring(s.lastIndexOf('/') + 1));
    return returner;
  }

  public void loeschegelaende(int x, int y) {
    ResultSet result;
    int b = 1;
    int l = 1;
    if (gelaendes[x][laenge - 1 - y] != null &&
        gelaendes[x][laenge - 1 - y].charAt(0) == '/') {

      result = db.select(
          "select * from gelaende where name='" +
          (cgelaende.getItem(Integer.parseInt( (
          gelaendes[getkoordinaten(gelaendes[x][laenge - 1 - y])[0]]
          [getkoordinaten(gelaendes[x][laenge - 1 - y])[1]])))) + "'");

    }
    else if (gelaendes[x][laenge - 1 - y] != null) {
      result = db.select(
          "select * from gelaende where name='" +
          (cgelaende.getItem(Integer.parseInt(gelaendes[x][laenge - 1 - y])))
          + "'");
    }
    else {
      result = db.select(
          "select * from gelaende where name=''");
    }

    try {
      result.next();
      b = result.getInt("breite");
      l = result.getInt("laenge");
    }
    catch (SQLException ex) {
      System.out.println(ex);
    }
    int basisx = 0;
    int basisy = 0;
    if (gelaendes[x][laenge - 1 - y] != null &&
        gelaendes[x][laenge - 1 - y].charAt(0) == '/') {
      basisx = getkoordinaten(gelaendes[x][laenge - 1 - y])[0];
      basisy = getkoordinaten(gelaendes[x][laenge - 1 - y])[1];
    }
    else {
      basisx = x;
      basisy = laenge - 1 - y;
    }
    if (b > 1 || l > 1) {
      for (int i = 0; i < b; i++) {
        for (int j = 0; j < l; j++) {
          gelaendes[basisx + i][basisy + j] = null;
        }
      }
    }

    gelaendes[x][laenge - 1 - y] = null;

  }

  void czoom_itemStateChanged(ItemEvent e) {
    sp.setSize( (Integer.parseInt(czoom.getSelectedItem()) / 5) * breite + 2,
              (Integer.parseInt(czoom.getSelectedItem()) / 5) * laenge + 2);

    feldhalter.doLayout();
  }

  void cbgelaende_itemStateChanged(ItemEvent e) {
    sp.repaint();
  }

  void cbminen_itemStateChanged(ItemEvent e) {
    sp.repaint();
  }

  void cbhoehen_itemStateChanged(ItemEvent e) {
    sp.repaint();
  }

  void bspeichern_actionPerformed(ActionEvent e) {
    boolean fehler = false;
    if (tname.getText().equals("")) {
      Warnung w = new Warnung("Bitte Namen angeben!");
      fehler = true;
    }
    ResultSet nresult;
    nresult = db.select("select name from spielfeld");

    try {
      if (andernid == 0 || !altername.equals(tname.getText())) {
        while (nresult.next()) {
          if (nresult.getString("name").equals(tname.getText())) {
            Warnung w = new Warnung("" + tname.getText() + " gibt es schon!");
            fehler = true;
          }
        }
      }
    }
    catch (SQLException ex) {
      System.out.println("Problem");
    }

    if (!fehler) {
      if (andernid == 0) {
        int uid=0;
        db.select("select uid from umgebung where uname='"+tumgebung.getText()+"'");
        db.mach("insert into spielfeld (name,laenge,breite,uid)values('" +
                tname.getText() + "','" + laenge + "','" + breite + "','" + uid + "')");
      }
      else {
        db.mach("update spielfeld set name='" + tname.getText() +
                "' where spid='" + andernid + "'");
        db.mach("delete from kachel where spid='" + andernid + "'");
      }

    }

    ResultSet result, mresult, gresult;
    result = db.select("Select spid from spielfeld where name='" +
                       tname.getText() + "'");
    int spid = 0;
    String mid = new String("");
    String gid = new String("");
    String hoehe = new String("");
    try {
      result.next();
      spid = result.getInt("spid");
    }
    catch (SQLException ex) {
    }
    if (!fehler) {
      for (int i = 0; i < breite; i++) {
        for (int j = 0; j < laenge; j++) {
          if (mines[i][j] != null) {
            mresult = db.select("Select mid from mine where name='" +
                                cmine.getItem(Integer.parseInt(mines[i][j])) +
                                "'");
            try {
              mresult.next();
              mid = mresult.getString("mid");
            }
            catch (SQLException ex1) {
            }
          }
          else {
            mid = "";
          }
          if (gelaendes[i][j] != null && gelaendes[i][j].charAt(0) != '/') {
            gresult = db.select("Select gid from gelaende where name='" +
                                cgelaende.getItem(Integer.parseInt(gelaendes[i][
                j])) + "'");
            try {
              gresult.next();
              gid = gresult.getString("gid");
            }
            catch (SQLException ex1) {
            }
          }
          else {
            gid = "";
          }
          if (hoehen[i][j] != null) {
            hoehe = hoehen[i][j];
          }
          else hoehe="0";

          String stmt = new String(
              "insert into kachel (spid,mid,gid,hoehe,x,y)values('" + spid +
              "','" + mid + "','" + gid + "','" + hoehe + "','" + i +
              "','" + j + "')");
          db.mach(stmt);

        }
      }
    }
  }

    public void update(Graphics g){
        // double buffering
        Image img = createImage(getWidth(),getHeight());
        // weggelassen Malen eines neuen Hintergrundes
        Graphics g1 = img.getGraphics();
        paint(g1);
        g.drawImage(img, 0, 0, this);

    }



}

class Spielfeldgui_babbrechen_actionAdapter
    implements java.awt.event.ActionListener {
  Spielfeldgui adaptee;

  Spielfeldgui_babbrechen_actionAdapter(Spielfeldgui adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.babbrechen_actionPerformed(e);
  }
}

class Spielfeldgui_czoom_itemAdapter
    implements java.awt.event.ItemListener {
  Spielfeldgui adaptee;

  Spielfeldgui_czoom_itemAdapter(Spielfeldgui adaptee) {
    this.adaptee = adaptee;
  }

  public void itemStateChanged(ItemEvent e) {
    adaptee.czoom_itemStateChanged(e);
  }
}

class Spielfeldgui_cbgelaende_itemAdapter
    implements java.awt.event.ItemListener {
  Spielfeldgui adaptee;

  Spielfeldgui_cbgelaende_itemAdapter(Spielfeldgui adaptee) {
    this.adaptee = adaptee;
  }

  public void itemStateChanged(ItemEvent e) {
    adaptee.cbgelaende_itemStateChanged(e);
  }
}

class Spielfeldgui_cbminen_itemAdapter
    implements java.awt.event.ItemListener {
  Spielfeldgui adaptee;

  Spielfeldgui_cbminen_itemAdapter(Spielfeldgui adaptee) {
    this.adaptee = adaptee;
  }

  public void itemStateChanged(ItemEvent e) {
    adaptee.cbminen_itemStateChanged(e);
  }
}

class Spielfeldgui_cbhoehen_itemAdapter
    implements java.awt.event.ItemListener {
  Spielfeldgui adaptee;

  Spielfeldgui_cbhoehen_itemAdapter(Spielfeldgui adaptee) {
    this.adaptee = adaptee;
  }

  public void itemStateChanged(ItemEvent e) {
    adaptee.cbhoehen_itemStateChanged(e);
  }
}

class Spielfeldgui_bspeichern_actionAdapter
    implements java.awt.event.ActionListener {
  Spielfeldgui adaptee;

  Spielfeldgui_bspeichern_actionAdapter(Spielfeldgui adaptee) {
    this.adaptee = adaptee;
  }

  public void actionPerformed(ActionEvent e) {
    adaptee.bspeichern_actionPerformed(e);
  }
}